'CHARACTER INFO by Sober Panda
'Contact: david@soberpanda.com
'For usage instructions, type "/info help" in the chat window.
'Please report errors to david@soberpanda.com.


#register /info Info Character Info by Sober Panda. Type "/info help" to view help information.

sub Info()
	On Error Resume Next

	cs = GetChatSession() 
	ci = cs.GetLastItem()
	os = GetCurrentSession()

	PName = Trim(ci.Text)

	p = GetCurrentPlayer()
	If PName = "" Then c = p.GetCharacterByIndex(0) Else c = p.GetCharacter(PName)

	NameVal = os.GetField("NameField")
	HitsVal = os.GetField("HitsField")
	StatusVal = os.GetField("StatusField")
	InfoVal = os.GetField("InfoField")

	If NameVal = "" Then os.SetField NameField, "ON"
	If HitsVal = "" Then os.SetField HitsField, "ON"
	If StatusVal = "" Then os.SetField StatusField, "ON"
	If InfoVal = "" Then os.SetField InfoField, "ON"

	ci.PlayerTo = ci.PlayerFrom
	ci.Text = LCase(ci.Text)

	InfoAction = 0
	ActionCheck = Left(ci.Text, 2)
	If ActionCheck = " +" or ActionCheck = " -" Then InfoAction = 1
	ActionCheck = Left(ci.Text, 5)
	If ActionCheck = " help" Then InfoAction = 2

	If InfoAction = 1 and p.isGM = True Then
		Select Case ci.Text
		Case " +n"
			NameVal = "ON"
			ci.Action = "edited the /info N property"
			ci.Text = "N is now ON."
		Case " +h"
			HitsVal = "ON"
			ci.Action = "edited the /info H property"
			ci.Text = "H is now ON."
		Case " +s"
			StatusVal = "ON"
			ci.Action = "edited the /info S property"
			ci.Text = "S is now ON."
		Case " +i"
			InfoVal = "ON"
			ci.Action = "edited the /info I property"
			ci.Text = "I is now ON."
		Case " -n"
			NameVal = "OFF"
			ci.Action = "edited the /info N property"
			ci.Text = "N is now OFF."
		Case " -h"
			HitsVal = "OFF"
			ci.Action = "edited the /info H property"
			ci.Text = "H is now OFF."
		Case " -s"
			StatusVal = "OFF"
			ci.Action = "edited the /info S property"
			ci.Text = "S is now OFF."
		Case " -i"
			InfoVal = "OFF"
			ci.Action = "edited the /info I property"
			ci.Text = "I is now OFF."
		Case Else
			ci.Action = "attempted to edit an /info property"
			ci.Text = "INameValid property."
		End Select
	ElseIf InfoAction = 1 and p.isGM = False Then
		ci.PlayerTo = ci.PlayerFrom
		ci.Action = "attempted to edit a /info property"
		ci.Text = "Only the GM can edit /info properties."

	ElseIf InfoAction = 2 Then
		ci.Action = "requested help information for /info"
		ci.Text = "<DD><B>/info</B> : Reports info for the first characer owned by the player."
		ci.Text = ci.Text + "<DD><B>/info <I>name</I></B> : Reports info for the character named <I>name</I>."
		ci.Text = ci.Text + "<DD><B>/info +<I>prop</I></B> : Enables the property <I>prop</I>."
		ci.Text = ci.Text + "<DD><B>/info -<I>prop</I></B> : Disables the property <I>prop</I>."
		ci.Text = ci.Text + "<DD><B>/info report</B> : Displays the current status of all properties."
		ci.Text = ci.Text + "<BR>"

	ElseIf ci.Text = " report" Then
		ci.PlayerTo = ci.PlayerFrom
		ci.Action = "requested a property report from /info"
		ci.Text = "<table border=0 cellpadding=4 cellspacing=0><tr><td align=center><B>N</B></td><td>Toggles Name</td><td>" + NameVal + "</td></tr><td align=center><B>H</B></td><td>Toggles Hits</td><td>" + HitsVal + "</td></tr><td align=center><B>S</B></td><td>Toggles Status</td><td>" + StatusVal + "</td></tr><td align=center><B>I</B></td><td>Toggles Info</td><td>" + InfoVal + "</td></tr></table>"

	ElseIf InfoAction = 0 Then
		ci.Action = "character report"
		If NameVal = "ON" Then ci.Text = "<BR><B>Name:</B> " + c.Name
		If HitsVal = "ON" and c.Hits >< "" Then ci.Text = ci.Text + "<BR><B>Hits:</B> " + CStr(c.Hits)
		If StatusVal = "ON" and c.Status >< "" Then ci.Text = ci.Text + "<BR><B>Status:</B> " + c.Status
		If InfoVal = "ON" Then ci.Text = ci.Text + "<BR><B>Info:</B> " + c.Info
	End If

	os.SetField "NameField", NameVal
	os.SetField "HitsField", HitsVal
	os.SetField "StatusField", StatusVal
	os.SetField "InfoField", InfoVal

End Sub